<template>
  <rui-form :errors="errors"
            model="layer"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field input-id="layer_name" :label="$t('activerecord.attributes.layer.name')">
      <input id="layer_name" v-model="inputs.name" type="text" required>
    </rui-field>

    <rui-field>
      <label for="layer_visible_by_default">
        <input id="layer_visible_by_default" v-model="inputs.visible_by_default" type="checkbox">
        {{ $t('activerecord.attributes.layer.visible_by_default') }}
      </label>
    </rui-field>
  </rui-form>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaLayerForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiField, RuiForm },
  props: {
    layer: { required: false, type: Object, default: null },
    newLayerMapId: { required: false, type: Number, default: null },
  },
  data () {
    return {
      inputs: this.fillInputs(),
      errors: null,
      loading: false,
    }
  },
  methods: {
    fillInputs () {
      const inputs = {}
      if (this.$props.layer) {
        inputs.id = this.$props.layer.id
        inputs.name = this.$props.layer.name
        inputs.visible_by_default = this.$props.layer.visibleByDefault
      } else {
        inputs.id = null
        inputs.name = ''
        inputs.visible_by_default = true
        inputs.map_id = this.$props.newLayerMapId || parseInt(this.$route.params.mapId, 10)
      }

      return inputs
    },
    save () {
      const payload = { ...this.inputs }
      this.loading = true
      this.$store.dispatch('saveLayer', payload)
        .then(() => {
          this.$emit('saved')
          Toaster.success(this.$t('js.layers.form.successfully_created'))
          this.fillInputs()
        })
        .catch((errors) => {
          this.errors = errors
          Toaster.error(this.$t('js.layers.form.failed_to_create'))
        })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    layer () { this.inputs = this.fillInputs() },
    newLayerMapId (newValue) { this.inputs.map_id = newValue },
  },
}
</script>
